#---------------------------------------------------------------------
#     Copyright (C) GFD Dennou Club, 2005. All rights reserved.
#---------------------------------------------------------------------
#= Template File for "Config.mk", build configuration of dcpam (autoconf)
#
#   * Developers: Yasuhiro MORIKAWA, Masaki ISHIWATARI
#   * Version: $Id: Config.mk.in,v 1.2 2005/06/18 12:59:12 morikawa Exp $
#   * Tag Name: $Name: dcpam2-20050620 $
#   * Change History: 
#
#== Overview
#
# This file is template file to create "Config.mk" by
# autoconf 2.13. Some functions are defined in "aclocal.m4"
# (for example, DC_ARG_WITH).
#
# [JAPANESE]
# Υե Makefile ƤӽФե "Config.mk"
# οեǤ. configure ץȤˤäƤΥե
#  (@ ǰϤޤ줿ѿ) ֤, "Config.mk" ޤ.
# configure  configure.in  aclocal.m4  autoconf ޥɤ
# Ѥ뤳Ȥޤ.
#
############################################################

############################################################
#== for Debian install
#
# [JAPANESE] Debian 󥹥ȡ
#
DESTDIR = 

############################################################
#== Fortran Compiler
#
# [JAPANESE] Fortran ѥ
#
FC=frt

# Flags needed when compiled and linked
# [JAPANESE] ѥ󥯻ɬפʥե饰
SYSFFLAGS=-Kfast,parallel -I/usr/lib/spml-ssl2-ffc5/include -I/usr/lib/gt4f90io-ffc5/include -Am

# Flags needed when linked
# [JAPANESE] 󥯻ɬפʥե饰
SYSLDFLAGS=-L/usr/lib/spml-ssl2-ffc5/lib -L/usr/lib/gt4f90io-ffc5/lib -L/usr/lib -L/usr/lib

# Libraries needed when linked
# [JAPANESE] 󥯻ɬפʥ饤֥
SYSLDLIBS=-lspml-ssl2 -lgt4f90io -lnetcdf-ffc5 -lisp-ffc5

# Information of Modules (std.mod, HP.mod, fqs.mod, intel.d, hitachi.f90)
# [JAPANESE] ⥸塼Ϥ
F90MODTYPE=fqs.mod

# Extensions of Module Files (".mod" or ".d" or ".f90")
# [JAPANESE] ⥸塼եγĥ
MODEXT=.mod
#
# Extensions of Module Files used when "make clean"
# * if "F90MODTYPE = hitachi.f90", clean nothing.
#
# [JAPANESE]
# make clean ˻Ѥ⥸塼ե
# (F90MODTYPE = hitachi.f90 ΤȤϲäƤϤʤʤ)
#
MODS=*.mod

############################################################
#== library name lib$(LIBNAME).a
#
# [JAPANESE] 饤֥̾ lib$(LIBNAME).a
#
LIBNAME		= dcpam2
DCPAMLIB	= lib$(LIBNAME).a

############################################################
#== Directory to which the all files are archived
#
# [JAPANESE] ֤ԤΥǥ쥯ȥ
#
DCPAMDIR	= /GFD_Dennou_Club/ftp/arch/dcpam/dcpam2/dcpam2-20050620

MODDIR		= $(DCPAMDIR)/include
LIBDIR		= $(DCPAMDIR)/lib
BINDIR		= $(DCPAMDIR)/bin
DOCDIR		= $(DCPAMDIR)/doc

############################################################
#== Directory to which the all files are installed
#
# [JAPANESE] 󥹥ȡΥǥ쥯ȥ
#
prefix		= /usr/local/dcpam2
exec_prefix	= ${prefix}
dcpam_bin_suffix= 

INSTMODDIR	= $(DESTDIR)${prefix}/include
INSTLIBDIR	= $(DESTDIR)${exec_prefix}/lib
INSTBINDIR	= $(DESTDIR)${exec_prefix}/bin
INSTDOCDIR	= $(DESTDIR)${prefix}/doc



############################################################
#== Set Commands for compile and install source code
#
# Please edit according to your system.
#
# [JAPANESE] ѥ䥤󥹥ȡɬפʥޥɷ
#
# ƥ˹碌ѹƤ.
#
CP		= cp -p
INSTALL		= install -m 644
INSTALLBIN	= install -m 755
INSTALLDIR	= install -d -m 755
MKDIR		= mkdir
DIRNAME		= dirname
BASENAME	= basename
TOUCH		= touch
RM		= rm -f
GUNZIP		= gunzip # decompression  (equal to "gzip -d")
MAKE		= make   # GNU Make
MAKEALWAYS	= make --always-make
                         # all targets are remade without checking time
AR		= ar r   # AR : Library builder specification

############################################################
#== Set Commands for development
#
# [JAPANESE] ȯѤݤΥޥ
#
TAGS		= etags

############################################################
#== Set Commands for documentations
#
# [JAPANESE] ɥɬפʥޥ
#
RUBY		= ruby          # for Generation RD documents
RD2		= rd2           # for Generation RD documents
JLATEX		= platex        # for Generation DVI documents
DVI2PDF		= dvipdfm       # for Generation PDF documents
DVI2JPS		= dvi2ps        # for Generation PS documents
LPR		= lpr -s        # for Print out

#=== RD Document Setting
#
# [JAPANESE] RD ΤΥץ
#
#RUBYLIB = $(DESTDIR)
CSS            = css/dcpam-rd2html.css
RD2HTM_LIB     = $(RD2) -r rd/rd2html-lib
RD2_JA_FLAG    = --html-charset=EUC-JP --with-part=JA:rd
RD2_EN_FLAG    = --html-charset=US-ASCII --with-part=EN:rd
RD2_LIB_FLAG   = --with-part=HTML:include --out-code=euc
RD2HTM_EXT_LIB = $(RD2) -r rd/rd2html-ext-lib
EXT_LIB_FLAG   = --ref-extension --native-inline --head-element # --headline-secno
RD2_CSSFLAG    = --with-css=$(CSS)

RD2HTML        = $(RD2HTM_EXT_LIB) $(RDFLAG) $(RD2_CSSFLAG)
RD2MAN         = $(RD2) -r rd/rd2man-lib.rb
RD2LATEX       = $(RD2) -r rd/rd2latex-lib.rb \
                --documentclass="jarticle" \
                --documentclass-option="titlepage" \
                --title="DCPAM Reference Manual" \
                --author="GFD Dennou Club"  \
                --maketoc     \
                --maketitle

#=== dcnote command
#
# dcnote is available from
# http://www.gfd-dennou.org/arch/cc-env/dcnote/SIGEN.htm
#
# [JAPANESE] dcnote Ѥݤɬפ
#
# dcnote ϰʲ URL Ǥޤ.
# http://www.gfd-dennou.org/arch/cc-env/dcnote/SIGEN.htm
#
ICONDIR = /usr/lib/dcnote

DCNOTE-PS2GIF= dcnote-ps2gif
DCNOTE-HTMS  = dcnote-htms -s $(ICONDIR)
DCNOTE-LATEX2DESC= dcnote-latex2desc
DCNOTE-MKINDEX= dcnote-mkindex

#=== latex2html_jp for Dennou.sty
#
# latex2html_jp+dennou is available from
# http://www.gfd-dennou.org/arch/cc-env/latex2html/SIGEN.htm
#
# [JAPANESE] latex2html_jp+dennnou Ѥݤɬפ
#
# latex2html_jp+dennou ϰʲ URL Ǥޤ.
# http://www.gfd-dennou.org/arch/cc-env/latex2html/SIGEN.htm
#
LATEX2HTML = latex2html
LATEX2HTMLOPTIONS = -no_footnode -local_icons -short_extn \
	-bottom_navigation -no_contents_in_navigation -no_auto_link \
	-up_url $(HREFTOPDIR)/index.htm -up_title $(HREFTOPDIRNAME) \
	-split 3 -show_section_numbers -dir $(TARGETHTMDIR) 


############################################################
#== Suffixes rules
#
# [JAPANESE] եå롼
#
.SUFFIXES: .f90 .htm .3f .tex .pdf

%.o: %.f90
	@test -d $(LIBDIR) || \
	    eval "$(INSTALLDIR) $(LIBDIR) ; echo $(INSTALLDIR) $(LIBDIR)"
	@test -d $(MODDIR) || \
	    eval "$(INSTALLDIR) $(MODDIR) ; echo $(INSTALLDIR) $(MODDIR)"
	cd `$(DIRNAME) $@` ;\
	    $(FC) -c $(FFLAGS) $(FCFLAGS) -I$(MODDIR) $(SYSFFLAGS) `$(BASENAME) $<`
	cd `$(DIRNAME) $@` ;\
	    $(AR) $(LIBDIR)/$(DCPAMLIB) $@ ;\
	    ls $(MODS) >/dev/null 2>&1 && \
		for i in $(MODS) ; do \
		    $(INSTALL) $$i $(MODDIR) ;\
		done \
	        || echo $(MODS) "are not found"


.f90.htm:
	sed 's/^[	 ]*!//' $< > $<.rd
	$(RD2HTML) $<.rd > $@.tmp || rm -f $@.tmp $<.rd
	mv $@.tmp $@
	rm -f $<.rd

.f90.3f:
	sed 's/^[	 ]*!//' $< > $<.rd
	$(RD2MAN) $<.rd > $@.tmp || rm -f $@.tmp $<.rd
	mv $@.tmp $@
	rm -f $<.rd

.f90.tex:
	sed 's/^[	 ]*!//' $< > $<.rd
	$(RD2LATEX) $<.rd > $@.tmp || rm -f $@.tmp $<.rd
	mv $@.tmp $@
	rm -f $<.rd

.f90.pdf:
	sed 's/^[	 ]*!//' $< > $<.rd
	$(RD2LATEX) $<.rd > $@.tmp || rm -f $@.tmp $<.rd
	mv $@.tmp $@
	rm -f $<.rd
	$(PLATEX) $@ ; $(PLATEX) $@
	rm -f $*.aux $*.toc $*.log
	$(DVI2PDF) $*.dvi
